# Delay Differential Equations (DDE)

## Features

* Autonomous DDEs with multiple dynamical variables and multiple delay times
* Driven systems (i.e. with external input)
* Non-autonomous DDEs (using driven systems with time as external input)
* Second and fourth order integration methods
* Example models:
   * [Mackey-Glass](https://github.com/masterdezign/dde/blob/master/examples/MackeyGlass/Main.hs) with no external input
   * [Driven system](https://github.com/masterdezign/dde/blob/80de41dd8c04c18cf439dee33bc117c96c212699/dde/Numeric/DDE/Model.hs#L60)
   * [Two delays](https://github.com/masterdezign/dde/blob/master/examples/Chimera/Main.hs)
* Pure Haskell

## Acknowledgements

* [Justus Sagemüller](https://github.com/leftaroundabout) for making this library faster
